<h1 id="naming-strategies">Naming Strategies</h1>
<h2 id="the-underscored-option">The <code>underscored</code> option</h2>
<p>Sequelize provides the <code>underscored</code> option for a model. When <code>true</code>, this option will set the <code>field</code> option on all attributes to the <a href="https://en.wikipedia.org/wiki/Snake_case">snake_case</a> version of its name. This also applies to foreign keys automatically generated by associations and other automatically generated fields. Example:</p>
<div class="sourceCode" id="cb1"><pre class="sourceCode js"><code class="sourceCode javascript"><a class="sourceLine" id="cb1-1" title="1"><span class="kw">const</span> User <span class="op">=</span> <span class="va">sequelize</span>.<span class="at">define</span>(<span class="st">&#39;user&#39;</span><span class="op">,</span> <span class="op">{</span> <span class="dt">username</span><span class="op">:</span> <span class="va">Sequelize</span>.<span class="at">STRING</span> <span class="op">},</span> <span class="op">{</span></a>
<a class="sourceLine" id="cb1-2" title="2">  <span class="dt">underscored</span><span class="op">:</span> <span class="kw">true</span></a>
<a class="sourceLine" id="cb1-3" title="3"><span class="op">}</span>)<span class="op">;</span></a>
<a class="sourceLine" id="cb1-4" title="4"><span class="kw">const</span> Task <span class="op">=</span> <span class="va">sequelize</span>.<span class="at">define</span>(<span class="st">&#39;task&#39;</span><span class="op">,</span> <span class="op">{</span> <span class="dt">title</span><span class="op">:</span> <span class="va">Sequelize</span>.<span class="at">STRING</span> <span class="op">},</span> <span class="op">{</span></a>
<a class="sourceLine" id="cb1-5" title="5">  <span class="dt">underscored</span><span class="op">:</span> <span class="kw">true</span></a>
<a class="sourceLine" id="cb1-6" title="6"><span class="op">}</span>)<span class="op">;</span></a>
<a class="sourceLine" id="cb1-7" title="7"><span class="va">User</span>.<span class="at">hasMany</span>(Task)<span class="op">;</span></a>
<a class="sourceLine" id="cb1-8" title="8"><span class="va">Task</span>.<span class="at">belongsTo</span>(User)<span class="op">;</span></a></code></pre></div>
<p>Above we have the models User and Task, both using the <code>underscored</code> option. We also have a One-to-Many relationship between them. Also, recall that since <code>timestamps</code> is true by default, we should expect the <code>createdAt</code> and <code>updatedAt</code> fields to be automatically created as well.</p>
<p>Without the <code>underscored</code> option, Sequelize would automatically define:</p>
<ul>
<li>A <code>createdAt</code> attribute for each model, pointing to a column named <code>createdAt</code> in each table</li>
<li>An <code>updatedAt</code> attribute for each model, pointing to a column named <code>updatedAt</code> in each table</li>
<li>A <code>userId</code> attribute in the <code>Task</code> model, pointing to a column named <code>userId</code> in the task table</li>
</ul>
<p>With the <code>underscored</code> option enabled, Sequelize will instead define:</p>
<ul>
<li>A <code>createdAt</code> attribute for each model, pointing to a column named <code>created_at</code> in each table</li>
<li>An <code>updatedAt</code> attribute for each model, pointing to a column named <code>updated_at</code> in each table</li>
<li>A <code>userId</code> attribute in the <code>Task</code> model, pointing to a column named <code>user_id</code> in the task table</li>
</ul>
<p>Note that in both cases the fields are still <a href="https://en.wikipedia.org/wiki/Camel_case">camelCase</a> in the JavaScript side; this option only changes how these fields are mapped to the database itself. The <code>field</code> option of every attribute is set to their snake_case version, but the attribute itself remains camelCase.</p>
<p>This way, calling <code>sync()</code> on the above code will generate the following:</p>
<div class="sourceCode" id="cb2"><pre class="sourceCode sql"><code class="sourceCode sql"><a class="sourceLine" id="cb2-1" title="1"><span class="kw">CREATE</span> <span class="kw">TABLE</span> <span class="cf">IF</span> <span class="kw">NOT</span> <span class="kw">EXISTS</span> <span class="ot">&quot;users&quot;</span> (</a>
<a class="sourceLine" id="cb2-2" title="2">  <span class="ot">&quot;id&quot;</span> SERIAL,</a>
<a class="sourceLine" id="cb2-3" title="3">  <span class="ot">&quot;username&quot;</span> <span class="dt">VARCHAR</span>(<span class="dv">255</span>),</a>
<a class="sourceLine" id="cb2-4" title="4">  <span class="ot">&quot;created_at&quot;</span> <span class="dt">TIMESTAMP</span> <span class="kw">WITH</span> <span class="dt">TIME</span> <span class="dt">ZONE</span> <span class="kw">NOT</span> <span class="kw">NULL</span>,</a>
<a class="sourceLine" id="cb2-5" title="5">  <span class="ot">&quot;updated_at&quot;</span> <span class="dt">TIMESTAMP</span> <span class="kw">WITH</span> <span class="dt">TIME</span> <span class="dt">ZONE</span> <span class="kw">NOT</span> <span class="kw">NULL</span>,</a>
<a class="sourceLine" id="cb2-6" title="6">  <span class="kw">PRIMARY</span> <span class="kw">KEY</span> (<span class="ot">&quot;id&quot;</span>)</a>
<a class="sourceLine" id="cb2-7" title="7">);</a>
<a class="sourceLine" id="cb2-8" title="8"><span class="kw">CREATE</span> <span class="kw">TABLE</span> <span class="cf">IF</span> <span class="kw">NOT</span> <span class="kw">EXISTS</span> <span class="ot">&quot;tasks&quot;</span> (</a>
<a class="sourceLine" id="cb2-9" title="9">  <span class="ot">&quot;id&quot;</span> SERIAL,</a>
<a class="sourceLine" id="cb2-10" title="10">  <span class="ot">&quot;title&quot;</span> <span class="dt">VARCHAR</span>(<span class="dv">255</span>),</a>
<a class="sourceLine" id="cb2-11" title="11">  <span class="ot">&quot;created_at&quot;</span> <span class="dt">TIMESTAMP</span> <span class="kw">WITH</span> <span class="dt">TIME</span> <span class="dt">ZONE</span> <span class="kw">NOT</span> <span class="kw">NULL</span>,</a>
<a class="sourceLine" id="cb2-12" title="12">  <span class="ot">&quot;updated_at&quot;</span> <span class="dt">TIMESTAMP</span> <span class="kw">WITH</span> <span class="dt">TIME</span> <span class="dt">ZONE</span> <span class="kw">NOT</span> <span class="kw">NULL</span>,</a>
<a class="sourceLine" id="cb2-13" title="13">  <span class="ot">&quot;user_id&quot;</span> <span class="dt">INTEGER</span> <span class="kw">REFERENCES</span> <span class="ot">&quot;users&quot;</span> (<span class="ot">&quot;id&quot;</span>) <span class="kw">ON</span> <span class="kw">DELETE</span> <span class="kw">SET</span> <span class="kw">NULL</span> <span class="kw">ON</span> <span class="kw">UPDATE</span> <span class="kw">CASCADE</span>,</a>
<a class="sourceLine" id="cb2-14" title="14">  <span class="kw">PRIMARY</span> <span class="kw">KEY</span> (<span class="ot">&quot;id&quot;</span>)</a>
<a class="sourceLine" id="cb2-15" title="15">);</a></code></pre></div>
<h2 id="singular-vs.-plural">Singular vs. Plural</h2>
<p>At a first glance, it can be confusing whether the singular form or plural form of a name shall be used around in Sequelize. This section aims at clarifying that a bit.</p>
<p>Recall that Sequelize uses a library called <a href="https://www.npmjs.com/package/inflection">inflection</a> under the hood, so that irregular plurals (such as <code>person -&gt; people</code>) are computed correctly. However, if you’re working in another language, you may want to define the singular and plural forms of names directly; sequelize allows you to do this with some options.</p>
<h3 id="when-defining-models">When defining models</h3>
<p>Models should be defined with the singular form of a word. Example:</p>
<div class="sourceCode" id="cb3"><pre class="sourceCode js"><code class="sourceCode javascript"><a class="sourceLine" id="cb3-1" title="1"><span class="va">sequelize</span>.<span class="at">define</span>(<span class="st">&#39;foo&#39;</span><span class="op">,</span> <span class="op">{</span> <span class="dt">name</span><span class="op">:</span> <span class="va">DataTypes</span>.<span class="at">STRING</span> <span class="op">}</span>)<span class="op">;</span></a></code></pre></div>
<p>Above, the model name is <code>foo</code> (singular), and the respective table name is <code>foos</code>, since Sequelize automatically gets the plural for the table name.</p>
<h3 id="when-defining-a-reference-key-in-a-model">When defining a reference key in a model</h3>
<div class="sourceCode" id="cb4"><pre class="sourceCode js"><code class="sourceCode javascript"><a class="sourceLine" id="cb4-1" title="1"><span class="va">sequelize</span>.<span class="at">define</span>(<span class="st">&#39;foo&#39;</span><span class="op">,</span> <span class="op">{</span></a>
<a class="sourceLine" id="cb4-2" title="2">  <span class="dt">name</span><span class="op">:</span> <span class="va">DataTypes</span>.<span class="at">STRING</span><span class="op">,</span></a>
<a class="sourceLine" id="cb4-3" title="3">  <span class="dt">barId</span><span class="op">:</span> <span class="op">{</span></a>
<a class="sourceLine" id="cb4-4" title="4">    <span class="dt">type</span><span class="op">:</span> <span class="va">DataTypes</span>.<span class="at">INTEGER</span><span class="op">,</span></a>
<a class="sourceLine" id="cb4-5" title="5">    <span class="dt">allowNull</span><span class="op">:</span> <span class="kw">false</span><span class="op">,</span></a>
<a class="sourceLine" id="cb4-6" title="6">    <span class="dt">references</span><span class="op">:</span> <span class="op">{</span></a>
<a class="sourceLine" id="cb4-7" title="7">      <span class="dt">model</span><span class="op">:</span> <span class="st">&quot;bars&quot;</span><span class="op">,</span></a>
<a class="sourceLine" id="cb4-8" title="8">      <span class="dt">key</span><span class="op">:</span> <span class="st">&quot;id&quot;</span></a>
<a class="sourceLine" id="cb4-9" title="9">    <span class="op">},</span></a>
<a class="sourceLine" id="cb4-10" title="10">    <span class="dt">onDelete</span><span class="op">:</span> <span class="st">&quot;CASCADE&quot;</span></a>
<a class="sourceLine" id="cb4-11" title="11">  <span class="op">},</span></a>
<a class="sourceLine" id="cb4-12" title="12"><span class="op">}</span>)<span class="op">;</span></a></code></pre></div>
<p>In the above example we are manually defining a key that references another model. It’s not usual to do this, but if you have to, you should use the table name there. This is because the reference is created upon the referencced table name. In the example above, the plural form was used (<code>bars</code>), assuming that the <code>bar</code> model was created with the default settings (making its underlying table automatically pluralized).</p>
<h3 id="when-retrieving-data-from-eager-loading">When retrieving data from eager loading</h3>
<p>When you perform an <code>include</code> in a query, the included data will be added to an extra field in the returned objects, according to the following rules:</p>
<ul>
<li>When including something from a single association (<code>hasOne</code> or <code>belongsTo</code>) - the field name will be the singular version of the model name;</li>
<li>When including something from a multiple association (<code>hasMany</code> or <code>belongsToMany</code>) - the field name will be the plural form of the model.</li>
</ul>
<p>In short, the name of the field will take the most logical form in each situation.</p>
<p>Examples:</p>
<div class="sourceCode" id="cb5"><pre class="sourceCode js"><code class="sourceCode javascript"><a class="sourceLine" id="cb5-1" title="1"><span class="co">// Assuming Foo.hasMany(Bar)</span></a>
<a class="sourceLine" id="cb5-2" title="2"><span class="kw">const</span> foo <span class="op">=</span> <span class="va">Foo</span>.<span class="at">findOne</span>(<span class="op">{</span> <span class="dt">include</span><span class="op">:</span> Bar <span class="op">}</span>)<span class="op">;</span></a>
<a class="sourceLine" id="cb5-3" title="3"><span class="co">// foo.bars will be an array</span></a>
<a class="sourceLine" id="cb5-4" title="4"><span class="co">// foo.bar will not exist since it doens&#39;t make sense</span></a>
<a class="sourceLine" id="cb5-5" title="5"></a>
<a class="sourceLine" id="cb5-6" title="6"><span class="co">// Assuming Foo.hasOne(Bar)</span></a>
<a class="sourceLine" id="cb5-7" title="7"><span class="kw">const</span> foo <span class="op">=</span> <span class="va">Foo</span>.<span class="at">findOne</span>(<span class="op">{</span> <span class="dt">include</span><span class="op">:</span> Bar <span class="op">}</span>)<span class="op">;</span></a>
<a class="sourceLine" id="cb5-8" title="8"><span class="co">// foo.bar will be an object (possibly null if there is no associated model)</span></a>
<a class="sourceLine" id="cb5-9" title="9"><span class="co">// foo.bars will not exist since it doens&#39;t make sense</span></a>
<a class="sourceLine" id="cb5-10" title="10"></a>
<a class="sourceLine" id="cb5-11" title="11"><span class="co">// And so on.</span></a></code></pre></div>
<h3 id="overriding-singulars-and-plurals-when-defining-aliases">Overriding singulars and plurals when defining aliases</h3>
<p>When defining an alias for an association, instead of using simply <code>{ as: 'myAlias' }</code>, you can pass an object to specify the singular and plural forms:</p>
<div class="sourceCode" id="cb6"><pre class="sourceCode js"><code class="sourceCode javascript"><a class="sourceLine" id="cb6-1" title="1"><span class="va">Project</span>.<span class="at">belongsToMany</span>(User<span class="op">,</span> <span class="op">{</span></a>
<a class="sourceLine" id="cb6-2" title="2">  <span class="dt">as</span><span class="op">:</span> <span class="op">{</span></a>
<a class="sourceLine" id="cb6-3" title="3">    <span class="dt">singular</span><span class="op">:</span> <span class="st">&#39;líder&#39;</span><span class="op">,</span></a>
<a class="sourceLine" id="cb6-4" title="4">    <span class="dt">plural</span><span class="op">:</span> <span class="st">&#39;líderes&#39;</span></a>
<a class="sourceLine" id="cb6-5" title="5">  <span class="op">}</span></a>
<a class="sourceLine" id="cb6-6" title="6"><span class="op">}</span>)<span class="op">;</span></a></code></pre></div>
<p>If you know that a model will always use the same alias in associations, you can provide the singular and plural forms directly to the model itself:</p>
<div class="sourceCode" id="cb7"><pre class="sourceCode js"><code class="sourceCode javascript"><a class="sourceLine" id="cb7-1" title="1"><span class="kw">const</span> User <span class="op">=</span> <span class="va">sequelize</span>.<span class="at">define</span>(<span class="st">&#39;user&#39;</span><span class="op">,</span> <span class="op">{</span> <span class="co">/* ... */</span> <span class="op">},</span> <span class="op">{</span></a>
<a class="sourceLine" id="cb7-2" title="2">  <span class="dt">name</span><span class="op">:</span> <span class="op">{</span></a>
<a class="sourceLine" id="cb7-3" title="3">    <span class="dt">singular</span><span class="op">:</span> <span class="st">&#39;líder&#39;</span><span class="op">,</span></a>
<a class="sourceLine" id="cb7-4" title="4">    <span class="dt">plural</span><span class="op">:</span> <span class="st">&#39;líderes&#39;</span><span class="op">,</span></a>
<a class="sourceLine" id="cb7-5" title="5">  <span class="op">}</span></a>
<a class="sourceLine" id="cb7-6" title="6"><span class="op">}</span>)<span class="op">;</span></a>
<a class="sourceLine" id="cb7-7" title="7"><span class="va">Project</span>.<span class="at">belongsToMany</span>(User)<span class="op">;</span></a></code></pre></div>
<p>The mixins added to the user instances will use the correct forms. For example, instead of <code>project.addUser()</code>, Sequelize will provide <code>project.getLíder()</code>. Also, instead of <code>project.setUsers()</code>, Sequelize will provide <code>project.setLíderes()</code>.</p>
<p>Note: recall that using <code>as</code> to change the name of the association will also change the name of the foreign key. Therefore it is recommended to also specify the foreign key(s) involved directly in this case.</p>
<div class="sourceCode" id="cb8"><pre class="sourceCode js"><code class="sourceCode javascript"><a class="sourceLine" id="cb8-1" title="1"><span class="co">// Example of possible mistake</span></a>
<a class="sourceLine" id="cb8-2" title="2"><span class="va">Invoice</span>.<span class="at">belongsTo</span>(Subscription<span class="op">,</span> <span class="op">{</span> <span class="dt">as</span><span class="op">:</span> <span class="st">&#39;TheSubscription&#39;</span> <span class="op">}</span>)<span class="op">;</span></a>
<a class="sourceLine" id="cb8-3" title="3"><span class="va">Subscription</span>.<span class="at">hasMany</span>(Invoice)<span class="op">;</span></a></code></pre></div>
<p>The first call above will establish a foreign key called <code>theSubscriptionId</code> on <code>Invoice</code>. However, the second call will also establish a foreign key on <code>Invoice</code> (since as we know, <code>hasMany</code> calls places foreign keys in the target model) - however, it will be named <code>subscriptionId</code>. This way you will have both <code>subscriptionId</code> and <code>theSubscriptionId</code> columns.</p>
<p>The best approach is to choose a name for the foreign key and place it explicitly in both calls. For example, if <code>subscription_id</code> was chosen:</p>
<div class="sourceCode" id="cb9"><pre class="sourceCode js"><code class="sourceCode javascript"><a class="sourceLine" id="cb9-1" title="1"><span class="co">// Fixed example</span></a>
<a class="sourceLine" id="cb9-2" title="2"><span class="va">Invoice</span>.<span class="at">belongsTo</span>(Subscription<span class="op">,</span> <span class="op">{</span> <span class="dt">as</span><span class="op">:</span> <span class="st">&#39;TheSubscription&#39;</span><span class="op">,</span> <span class="dt">foreignKey</span><span class="op">:</span> <span class="st">&#39;subscription_id&#39;</span> <span class="op">}</span>)<span class="op">;</span></a>
<a class="sourceLine" id="cb9-3" title="3"><span class="va">Subscription</span>.<span class="at">hasMany</span>(Invoice<span class="op">,</span> <span class="op">{</span> <span class="dt">foreignKey</span><span class="op">:</span> <span class="st">&#39;subscription_id&#39;</span> <span class="op">}</span>)<span class="op">;</span></a></code></pre></div>
